#!/usr/bin/env python

###NEWFD 0000 /home/jdupeyro/gcovtest/multithread.gcov.gcda 4707###
###NEWFD 0001 /home/jdupeyro/gcovtest/multithread.gcov.gcda 4708###
###DATA 0001 6164636770313034ffffff4e0000000102000000030000007cff27340000ff0108000000ff00000000000000ff00000000000000ff000000000000000100000000000000000000010200000004000000476155ff0000ff01080000006400000000000000640000000000000064000000000000000100000000000000 3491###
###DATA 0001 000000010200000005000000ff0a10ff0000ff010a00000001000000000000000100000000000000010000000000000001000000000000000100000000000000000000ff09000000000000000d00000001000000ff02000000000000ff00000000000000ff00000000000000000000ff09000000ff2e13ff0d000000 3506###
###DATA 0001 01000000ff02000000000000ff00000000000000ff0000000000000000000000 3624###
###CLOSE 0001 0193###

import sys
import re
import os

def cs(string):
    res = 0
    for c in string:
        res = (ord(c)+res)%10000
    return res

def buf(string):
    res = ""
    while(len(string)>=2):
	res=res+chr(int(string[0:2],16))
        string=string[2:]
    return res

def merge(buffer1,buffer2):
    if buffer1 == "":
        return buffer2
    else:
        return buffer1

### Case gcc 3.4
###
###     int32:  byte3 byte2 byte1 byte0 | byte0 byte1 byte2 byte3
###	int64:  int32:low int32:high
###	string: int32:0 | int32:length char* char:0 padding
###	padding: | char:0 | char:0 char:0 | char:0 char:0 char:0
###	item: int32 | int64 | string 
###     file : int32:magic int32:version int32:stamp record* 
###
###	record: header data
###	header: int32:tag int32:length
###	data: item*
###
###     data: {unit function-data* summary:object summary:program*}*
###	unit: header int32:checksum
###	function-data:	announce_function arc_counts
###	announce_function: header int32:ident int32:checksum
###	arc_counts: header int64:count*
###	summary: int32:checksum {count-summary}GCOV_COUNTERS
###	count-summary:	int32:num int32:runs int64:sum
###	          int64:max int64:sum_max
    return bufferres

NEWFD = re.compile("^###NEWFD (?P<fd>[0-9]{4}) (?P<filename>.+) (?P<cs>[0-9]{4})###$")
DATA = re.compile("^###DATA (?P<fd>[0-9]{4}) (?P<rawdata>[0-9a-f]+) (?P<cs>[0-9]{4})###$")
CLOSE = re.compile("^###CLOSE (?P<fd>[0-9]{4}) (?P<cs>[0-9]{4})###$")

fds = {}

lines = sys.stdin.readlines()

for line in lines:
    
    line = line.strip()
    match = NEWFD.match(line)
    if match:
        if cs(match.group('fd')+' '+match.group('filename')) != int(match.group('cs')):
	    print "INCORRECT "+str(cs(match.group('fd')))+line
        else:
            if str(int(match.group('fd'))) not in fds.keys():
                filename = match.group('filename')
                filename = filename.split(os.sep)[-1]
                orgfilename = filename
                try:
                    while os.stat(filename): # first non existing filename jumps out
                        filename=filename+".tmp"
                except Exception,e:
                    pass
                fds[str(int(match.group('fd')))] = {'name':orgfilename,'fd':open(filename,"wb")}
                print "CORRECT "+line
            else:
                print "INVALID ALREADY OPEN FD "+line
        continue
    match = DATA.match(line)
    if match:
        if cs(match.group('fd')+' '+match.group('rawdata')) != int(match.group('cs')):
            print "INCORRECT "+str(cs(match.group('fd')))+line
        else:
            if str(int(match.group('fd'))) not in fds.keys():
                print "INVALID UNKNOWN FD "+line
            else:
                fds[str(int(match.group('fd')))]['fd'].write(buf(match.group('rawdata')))
                print "CORRECT "+line
        continue
    match = CLOSE.match(line)
    if match:
        if cs(match.group('fd')) != int(match.group('cs')):
            print "INCORRECT "+str(cs(match.group('fd')))+line
        else:
            if str(int(match.group('fd'))) not in fds.keys():
                print "INVALID UNKNOWN FD "+line
            else:
		filename = fds[str(int(match.group('fd')))]['fd'].name
                if filename != fds[str(int(match.group('fd')))]['name']:
                    fds[str(int(match.group('fd')))]['fd'].close()
                    fd=open(filename,"rb")
                    buffer1 = fd.read()
                    fd.close()
                    os.unlink(filename)
                    fd=open(fds[str(int(match.group('fd')))]['name'],"rb")
                    buffer2 = fd.read()
                    fd.close()
                    bufferres=merge(buffer1,buffer2)
                    fd=open(fds[str(int(match.group('fd')))]['name'],"wb")
                    fd.write(bufferres)
                    fd.close()
	        else:
                    fds[str(int(match.group('fd')))]['fd'].close()
                del(fds[str(int(match.group('fd')))])
                print "CORRECT "+line
        continue
