#include "stdio.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>


#define DEBUG 1

/* Output format :
 *
 * "###NEWFD FD FILENAME CS###\n"
 * "###DATA FD DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD CS###\n"
 * "###CLOSE FD CS###\n"
 */

int cs(char * string){
   char * ptr = string;
   int res=0;
   while (*ptr != 0) {
       res = (*ptr + res)%10000;
       ptr++;
   }
   return res;
}
int fdall=0;
FILE arrayFILES[NBSOURCEFILES];
int open(const char *pathname, int flags, ...)
{
        int fd = fdall;
        char mystring[STRINGSIZE];
        fdall++;
        #ifdef DEBUG
	fprintf(stderr,"Call to open %s %d \n",pathname,flags);
        #endif
        sprintf(mystring,"%04d %s",fd,pathname);
        fprintf(stderr,"###NEWFD %s %04d###\n",mystring,cs(mystring));
	return fd;
}

FILE * fopen(const char *path, const char *mode)
{
        int fd = fdall;
        char mystring[STRINGSIZE];
        fdall++;
        #ifdef DEBUG
	fprintf(stderr,"Call to fopen %s\n",mode);
        #endif
        sprintf(mystring,"%04d %s",fd,path);
        fprintf(stderr,"###NEWFD %s %04d###\n",mystring,cs(mystring));
        return &arrayFILES[fd];
}

void setbuf(FILE *stream, char *buf)
{
        #ifdef DEBUG
	fprintf(stderr,"Call to setbuf\n");
        #endif
}
FILE *fdopen(int fildes, const char *mode)
{
        #ifdef DEBUG
	fprintf(stderr,"Call to fdopen %d %s \n",fildes,mode);
        #endif
	return &arrayFILES[fildes];
}

int close(int fd)
{
        char mystring[STRINGSIZE];
        #ifdef DEBUG
        fprintf(stderr,"Call to close %d\n",fd);
        #endif
        sprintf(mystring,"%04d",fd);
        fprintf(stderr,"###CLOSE %s %04d###\n",mystring,cs(mystring));
        return 0;

}

int fclose(FILE *fp)
{
        char mystring[STRINGSIZE];
        #ifdef DEBUG
	fprintf(stderr,"Call to fclose\n");
        #endif
        sprintf(mystring,"%04d",((unsigned int)fp-(unsigned int)&arrayFILES)/sizeof(FILE));
        fprintf(stderr,"###CLOSE %s %04d###\n",mystring,cs(mystring));
	return 0;
}

size_t fread(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
        #ifdef DEBUG
	fprintf(stderr,"Call to fread size = %d\n",size);
        #endif
	return 0;
}
int min(int a, int b) {
    if(a<b) return a;
    return b;
}
int gendatastring(char * string, int fd, char * ptr, int * size) {
    int i;
    int offset;
    if (*size == 0) {
        return 0;
    }
    sprintf(string,"%04d ",fd);
    offset = strlen(string);
    for(i=0; i<min(((STRINGSIZE-offset)/2)&0xFFFFFFFE,*size); i++) {
        sprintf(&string[offset+i*2],"%02x",(unsigned char)ptr[i]);
    }
    *size = *size - i;
    return i;
}
size_t fwrite(const void *ptr, size_t size, size_t nmemb, FILE *stream)
{
        char mystring[STRINGSIZE];
        int writtensize;
        
        #ifdef DEBUG
	fprintf(stderr,"Call to fwrite size = %d\n",size);
        #endif
        while((writtensize = gendatastring(mystring,((unsigned int)stream-(unsigned int)&arrayFILES)/sizeof(FILE),(char *)ptr,&size)) != 0) {
            fprintf(stderr,"###DATA %s %04d###\n",mystring,cs(mystring));
	    ptr = ptr + writtensize;
        }
	return size;
}
int fseek(FILE *stream, long offset, int whence)
{
        #ifdef DEBUG
	fprintf(stderr,"Call to fseek %d %d \n",offset,whence);
        #endif
	return 0;
}
int fcntl(int fd, int cmd, ...) {
    #ifdef DEBUG
    fprintf(stderr,"Call to fcntl %d %d\n",fd,cmd);
    #endif
    return 0;
}

